#include <stdio.h>
#include <lua.h>
#include <lauxlib.h>
#include <lualib.h>
#include <brick.h>
#include "lua-mod.h"
#include "lua-mod-audio.h"




/* they requested audio-mode info, so return the list: { none speaker .. } */
int wrap_audio_modes(lua_State *l)
{
	lua_pushstring(l, "speaker");
	return 1;
}




/* they requested to open the audio .. */
int wrap_audio_open(lua_State *l)
{
	const char *mode;
	int res;

	mode = lua_tostring(l, 1);

	if( !strcmp(mode, "speaker") )
		res = audio_open(AUDIO_SPEAKER);
	else
		res = ERR_BAD_MODE;

	/* if the result was an error, pass back an error code to lua */
	if( res < 0 )
		{
			switch(res)
				{
					case ERR_CANT_REOPEN: return luaL_error(l, "Audio already open ");
					case ERR_BAD_MODE: return luaL_error(l, "Unknown audio mode requested ");
					case ERR_SDL_FAILED: return luaL_error(l, "SDL could not open audio device ");
					case ERR_SDL_MIXER_FAILED: return luaL_error(l, "SDL_Mixer could not start ");
				}

		}

	return 0;

}




/* closing the audio .. */
int wrap_audio_close(lua_State *l)
{
	audio_close();
	return 0;
}



