#include <stdio.h>
#include <lua.h>
#include <lauxlib.h>
#include <lualib.h>
#include <brick.h>
#include "lua-mod.h"
#include "lua-mod-motion.h"









/* execute the motion-control code for each item in the given list */
int wrap_motion_list(lua_State *l)
{
	/* sprite list pointer */
	list *list;

	/* results */
	int res;

	/* walk a list, running each sprite's motion-control code */
	list = lua_touserdata(l, 1);
	res = motion_exec_list(list);

	/* check for errors */
	if( res < 0)
		{
			switch(res)
				{
					case ERR: return luaL_error(l, "Invalid sprite in list ");
					case ERR_BAD_INST_BC: return luaL_error(l, "Unknown instruction in bytecode ");
					case ERR_BAD_ARG_BC: return luaL_error(l, "Unknown argument in bytecode ");
					default: return luaL_error(l, "Unknown error ");
				}
		}

	return 0;

}




/* execute the motion-control code for a single item */
int wrap_motion_single(lua_State *l)
{
	/* sprite pointer */
	sprite *sprite;

	/* results */
	int res;


	/* run one sprite's motion-control code */
	sprite = lua_touserdata(l, 1);
	res = motion_exec_single(sprite);

	/* check for errors */
	if( res < 0)
		{
			switch(res)
				{
					case ERR: return luaL_error(l, "Invalid sprite ");
					case ERR_BAD_INST_BC: return luaL_error(l, "Unknown instruction in bytecode ");
					case ERR_BAD_ARG_BC: return luaL_error(l, "Unknown argument in bytecode ");
					default: return luaL_error(l, "Unknown error ");
				}
		}

	return 0;

}
