#include <stdio.h>
#include <lua.h>
#include <lauxlib.h>
#include <lualib.h>
#include <brick.h>
#include "lua-mod.h"
#include "lua-mod-render.h"





/* request to adjust the background-fill mode */
int wrap_render_bg_fill(lua_State *l)
{
	int mode;

	mode = lua_tonumber(l, 1);

	render_set_bg_fill(mode);
	return 0;
}



/* request to set the background fill color */
int wrap_render_bg_color(lua_State *l)
{
	int r, g, b;

	r = lua_tonumber(l, 1);
	g = lua_tonumber(l, 2);
	b = lua_tonumber(l, 3);

	render_set_bg_color((char)r, (char)g, (char)b);
	return 0;
}



/* a request to adjust the size of the internal render canvas */
int wrap_render_set_overdraw(lua_State *l)
{
	int w,h;

	w = lua_tonumber(l, 1);
	h = lua_tonumber(l, 2);

	render_set_overdraw(w, h);
	return 0;
}



/* render! */
int wrap_render_display(lua_State *l)
{
	render_display();
	return 0;
}



/* render to disk */
int wrap_render_to_disk(lua_State *l)
{
	/* the filename */
	const char *file;
	int res;


	/* attempt to write the frame to disk */
	file = lua_tostring(l, 1);
	res = render_to_disk(file);

	/* check for errors */
	if( res < 0 )
		{
			switch(res)
				{
					case ERR_BAD_FILE: return luaL_error(l, "Could not write to file ");
				}
		}

	return 0;
}


