#include <stdio.h>
#include <lua.h>
#include <lauxlib.h>
#include <lualib.h>
#include <brick.h>
#include "lua-mod.h"
#include "lua-mod-string.h"






/* create a new string */
int wrap_string_create(lua_State *l)
{
	lua_pushlightuserdata(l, string_create());
	return 1;
}



/* delete a string */
int wrap_string_delete(lua_State *l)
{
	string *string;

	string = lua_touserdata(l, 1);
	if( !string )
		return luaL_error(l, "Invalid string ");

	string_delete(string);
	return 0;
}



/* get the bounding region for a string */
int wrap_string_get_box(lua_State *l)
{
	string *string;
	int w, h;

	string = lua_touserdata(l, 1);
	if( !string )
		return luaL_error(l, "Invalid string ");

	if( string_get_box(string, &w, &h) == ERR )
		return luaL_error(l, "Invalid string ");
	else
		{
			lua_pushinteger(l, w);
			lua_pushinteger(l, h);
			return 2;
		}

	return 0;
}




/* set the font for a string */
int wrap_string_set_font(lua_State *l)
{
	string *string;
	const char *name;

	string = lua_touserdata(l, 1);
	if( !string )
		return luaL_error(l, "Invalid string ");

	name = lua_tostring(l, 2);

	string_set_font(string, name);
	return 0;
}



/* set string position */
int wrap_string_set_position(lua_State *l)
{
	string *string;
	int x,y;

	string = lua_touserdata(l, 1);
	if( !string )
		return luaL_error(l, "Invalid string ");

	x = lua_tonumber(l, 2);
	y = lua_tonumber(l, 3);

	string_set_position(string, x, y);
	return 0;
}



/* set the contents of a string */
int wrap_string_set_text(lua_State *l)
{
	string *string;
	const char *text;

	string = lua_touserdata(l, 1);
	if( !string )
		return luaL_error(l, "Invalid string ");

	text = lua_tostring(l, 2);

	string_set_text(string, text);
	return 0;
}
