#include <stdio.h>
#include <lua.h>
#include <lauxlib.h>
#include <lualib.h>
#include <brick.h>
#include "lua-mod.h"





const struct luaL_reg brick [] = {
	{ "graphics_open", wrap_graphics_open },
	{ "graphics_close", wrap_graphics_close },
	{ "graphics_window_title", wrap_graphics_window_title },
	{ "audio_modes", wrap_audio_modes },
	{ "audio_open", wrap_audio_open },
	{ "audio_close", wrap_audio_close },
	{ "io_fetch", wrap_io_fetch },
	{ "io_mouse", wrap_io_mouse },
	{ "io_has_quit", wrap_io_has_quit },
	{ "io_grab", wrap_io_grab },
	{ "io_wait", wrap_io_wait },
	{ "io_assign", wrap_io_assign },
	{ "io_read_key", wrap_io_read_key },
	{ "render_bg_fill", wrap_render_bg_fill },
	{ "render_bg_color", wrap_render_bg_color },
	{ "render_set_overdraw", wrap_render_set_overdraw },
	{ "render_display", wrap_render_display },
	{ "render_to_disk", wrap_render_to_disk },
	{ "font_add", wrap_font_add },
	{ "font_from_disk", wrap_font_from_disk },
	{ "font_from_buffer", wrap_font_from_buffer },
	{ "sound_load_file", wrap_sound_load_file },
	{ "sound_load_buffer", wrap_sound_load_buffer },
	{ "sound_load_raw", wrap_sound_load_raw },
	{ "sound_play", wrap_sound_play },
	{ "sound_halt", wrap_sound_halt },
	{ "sound_adj_vol", wrap_sound_adj_vol },
	{ "sound_adj_pan", wrap_sound_adj_pan },
	{ "song_play_file", wrap_song_play_file },
	{ "song_play_buffer", wrap_song_play_buffer },
	{ "song_pause", wrap_song_pause },
	{ "song_resume", wrap_song_resume },
	{ "song_halt", wrap_song_halt },
	{ "song_set_position", wrap_song_set_position },
	{ "song_adj_vol", wrap_song_adj_vol },
	{ "list_create", wrap_list_create },
	{ "list_empty", wrap_list_empty },
	{ "list_delete", wrap_list_delete },
	{ "list_add", wrap_list_add },
	{ "list_prepend", wrap_list_prepend },
	{ "list_shift", wrap_list_shift },
	{ "list_pop", wrap_list_pop },
	{ "list_remove", wrap_list_remove },
	{ "list_length", wrap_list_length },
	{ "list_find", wrap_list_find },
	{ "layer_add", wrap_layer_add },
	{ "layer_swap", wrap_layer_swap },
	{ "layer_remove", wrap_layer_remove },
	{ "layer_copy", wrap_layer_copy },
	{ "layer_sprite_list", wrap_layer_sprite_list },
	{ "layer_map", wrap_layer_map },
	{ "layer_string_list", wrap_layer_string_list },
	{ "layer_visible", wrap_layer_visible },
	{ "layer_sorting", wrap_layer_sorting },
	{ "layer_camera", wrap_layer_camera },
	{ "layer_view", wrap_layer_view },
	{ "frame_info", wrap_frame_info },
	{ "frame_create", wrap_frame_create },
	{ "frame_delete", wrap_frame_delete },
	{ "frame_copy", wrap_frame_copy },
	{ "frame_set_offset", wrap_frame_set_offset },
	{ "frame_set_mask", wrap_frame_set_mask },
	{ "frame_set_mask_from", wrap_frame_set_mask_from },
	{ "frame_slice", wrap_frame_slice },
	{ "frame_convert", wrap_frame_convert },
	{ "frame_effect", wrap_frame_effect },
	{ "frame_from_disk", wrap_frame_from_disk },
	{ "frame_from_buffer", wrap_frame_from_buffer },
	{ "map_create", wrap_map_create },
	{ "map_empty", wrap_map_empty },
	{ "map_delete", wrap_map_delete },
	{ "map_size", wrap_map_size },
	{ "map_tile_size", wrap_map_tile_size },
	{ "map_tile", wrap_map_tile },
	{ "map_set_data", wrap_map_set_data },
	{ "map_set_single", wrap_map_set_single },
	{ "map_animate_tiles", wrap_map_animate_tiles },
	{ "map_reset_tiles", wrap_map_reset_tiles },
	{ "tile_create", wrap_tile_create },
	{ "tile_delete", wrap_tile_delete },
	{ "tile_anim_type", wrap_tile_anim_type },
	{ "tile_collides", wrap_tile_collides },
	{ "tile_add_frame", wrap_tile_add_frame },
	{ "tile_add_frame_data", wrap_tile_add_frame_data },
	{ "tile_set_pixel_mask", wrap_tile_set_pixel_mask },
	{ "tile_set_pixel_mask_from", wrap_tile_set_pixel_mask_from },
	{ "tile_animate", wrap_tile_animate },
	{ "tile_reset", wrap_tile_reset },
	{ "sprite_create", wrap_sprite_create },
	{ "sprite_copy", wrap_sprite_copy },
	{ "sprite_delete", wrap_sprite_delete },
	{ "sprite_frame", wrap_sprite_frame },
	{ "sprite_scale", wrap_sprite_scale },
	{ "sprite_z_hint", wrap_sprite_z_hint },
	{ "sprite_collides", wrap_sprite_collides },
	{ "sprite_bounding_box", wrap_sprite_bounding_box },
	{ "sprite_set_pixel_mask", wrap_sprite_set_pixel_mask },
	{ "sprite_set_pixel_mask_from", wrap_sprite_set_pixel_mask_from },
	{ "sprite_position", wrap_sprite_position },
	{ "sprite_velocity", wrap_sprite_velocity },
	{ "sprite_add_frame", wrap_sprite_add_frame },
	{ "sprite_add_frame_data", wrap_sprite_add_frame_data },
	{ "sprite_add_subframe", wrap_sprite_add_subframe },
	{ "sprite_load_program", wrap_sprite_load_program },
	{ "string_create", wrap_string_create },
	{ "string_delete", wrap_string_delete },
	{ "string_get_box", wrap_string_get_box },
	{ "string_set_font", wrap_string_set_font },
	{ "string_set_position", wrap_string_set_position },
	{ "string_set_text", wrap_string_set_text },
	{ "inspect_adjacent_tiles", wrap_inspect_adjacent_tiles },
	{ "inspect_obscured_tiles", wrap_inspect_obscured_tiles },
	{ "inspect_line_of_sight", wrap_inspect_line_of_sight },
	{ "inspect_in_frame", wrap_inspect_in_frame },
	{ "inspect_near_point", wrap_inspect_near_point },
	{ "collision_map", wrap_collision_map },
	{ "collision_sprites", wrap_collision_sprites },
	{ "motion_list", wrap_motion_list },
	{ "motion_single", wrap_motion_single },
	{ "clock_ms", wrap_clock_ms },
	{ "clock_wait", wrap_clock_wait },
	{ NULL, NULL }  /* sentinel */
};







/* these are the lua init/exit routines */
int luaopen_brick (lua_State *l) {

	/* prepare the brick environment */
	init_brick();

	/* and load the library into the lua state */
	luaL_openlib(l, "brick", brick, 0);
	return 1;

}


