#include <stdio.h>
#include <unistd.h>
#include <lua.h>
#include <lauxlib.h>
#include <lualib.h>
#include <brick.h>
#if defined(__APPLE__)
#include <SDL/SDL.H>
#endif
#include "main.h"




/* the lua state */
lua_State *l;



int main(int argc, char *argv[]) {

	/* our game script, defaults to main.l */
	char *script_name = "main.lua";

	/* lua return code vars */
	int lua_ret;
	const char *lua_res;


	/* is there a command-line argument for a new script name? */
	if( argc == 2 )
		script_name = argv[1];


	/* initialize lua */
	l = lua_open();
	if( !l )
		fatal("Could not initialize lua!",4);

	/* initialize some basic libraries */
	luaL_openlibs(l);
	luaopen_brick(l);

	/* make sure we clean up nicely */
	atexit(quit_brick);


	/* run the lua program */
	lua_ret = luaL_dofile(l, script_name);
	if( lua_ret )
		{
			lua_res = lua_tostring(l,-1);
			printf( "lua quit with an error: %s\n", lua_res);
		}

	/* return the results of the lua script */
	return lua_ret;

}
